org.apache.tinkerpop.gremlin.process.traversal

## Enum Operator

- java.lang.Object
- - java.lang.Enum<Operator>
  - - org.apache.tinkerpop.gremlin.process.traversal.Operator

- All Implemented Interfaces:
    Serializable, Comparable<Operator>, BiFunction<Object,Object,Object>, BinaryOperator<Object>

      public enum Operator
      extends Enum<Operator>
      implements BinaryOperator<Object>

  A set of `BinaryOperator` instances that handle common operations for traversal steps.
  Author:
    Marko A. Rodriguez (http://markorodriguez.com)

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `addAll` Takes all objects in the second `Collection` and adds them to the first.
    `and` Applies "and" to boolean values.
    `assign` The new incoming value (i.e.
    `div` A division function.
    `max` Selects the larger of the values.
    `min` Selects the smaller of the values.
    `minus` A subtraction function.
    `mult` A multiplication function.
    `or` Applies "or" to boolean values.
    `sum` An addition function.
    `sumLong` Sums and adds long values.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static Operator` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static Operator[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.function.BinaryOperator

      `maxBy, minBy`

    - ### Methods inherited from interface java.util.function.BiFunction

      `andThen, apply`

- - ### Enum Constant Detail

    - #### sum

          public static final Operator sum

      An addition function.
      Since:
        3.0.0-incubating
      See Also:
        `NumberHelper.add(Number, Number)`

    - #### minus

          public static final Operator minus

      A subtraction function.
      Since:
        3.0.0-incubating
      See Also:
        `NumberHelper.sub(Number, Number)`

    - #### mult

          public static final Operator mult

      A multiplication function.
      Since:
        3.0.0-incubating
      See Also:
        `NumberHelper.mul(Number, Number)`

    - #### div

          public static final Operator div

      A division function.
      Since:
        3.0.0-incubating
      See Also:
        `NumberHelper.div(Number, Number)`

    - #### min

          public static final Operator min

      Selects the smaller of the values.
      Since:
        3.0.0-incubating
      See Also:
        `NumberHelper.min(Number, Number)`

    - #### max

          public static final Operator max

      Selects the larger of the values.
      Since:
        3.0.0-incubating
      See Also:
        `NumberHelper.max(Number, Number)`

    - #### assign

          public static final Operator assign

      The new incoming value (i.e. the second value to the function) is returned unchanged result in the assignment of that value to the object of the `Operator`.
      Since:
        3.1.0-incubating

    - #### and

          public static final Operator and

      Applies "and" to boolean values.

               a = true, b = null -> true
               a = false, b = null -> false
               a = null, b = true -> true
               a = null, b = false -> false
               a = null, b = null -> null

      Since:
        3.2.0-incubating

    - #### or

          public static final Operator or

      Applies "or" to boolean values.

               a = true, b = null -> true
               a = false, b = null -> false
               a = null, b = true -> true
               a = null, b = false -> false
               a = null, b = null -> null

      Since:
        3.2.0-incubating

    - #### addAll

          public static final Operator addAll

      Takes all objects in the second `Collection` and adds them to the first. If the first is `null`, then the second `Collection` is returned and if the second is `null` then the first is returned. If both are `null` then `null` is returned. Arguments must be of type `Map` or `Collection`.

      The semantics described above for `Collection` are the same when applied to a `Map`.
      Since:
        3.2.0-incubating

    - #### sumLong

          public static final Operator sumLong

      Sums and adds long values.
      Since:
        3.2.0-incubating

  - ### Method Detail

    - #### values

          public static Operator[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (Operator c : Operator.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static Operator valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

Copyright © 2013–2022 Apache Software Foundation. All rights reserved.